/*
 * Seq_functs.cpp
 *
 *  Created on: Oct 21, 2013
 *      Author: ckeme_01
 */

#include "Seq_functs.hpp"

namespace MDAT
{



void
reverse_complement(std::string &seq)
{
	size_t length =seq.size();
	std::reverse(seq.begin(), seq.end());
	std::vector<char>transformation(128,'!');
	transformation['A']='T';
	transformation['a']='t';
	transformation['C']='G';
	transformation['c']='g';
	transformation['T']='A';
	transformation['t']='a';
	transformation['G']='C';
	transformation['g']='c';
	transformation['R']='Y';
	transformation['r']='y';
	transformation['Y']='R';
	transformation['y']='r';
	transformation['M']='K';
	transformation['m']='k';
	transformation['K']='M';
	transformation['k']='m';
	transformation['W']='W';
	transformation['w']='w';
	transformation['S']='S';
	transformation['s']='s';
	transformation['B']='V';
	transformation['b']='v';
	transformation['V']='B';
	transformation['v']='b';
	transformation['D']='H';
	transformation['d']='h';
	transformation['H']='D';
	transformation['h']='d';
	transformation['N']='N';
	transformation['n']='n';
	transformation['-']='-';

	for (size_t i=0; i<length; ++i)
		seq[i] = transformation[seq[i]];
}

}
