/*
 * fastMath.hpp
 *
 *  Created on: Apr 1, 2014
 *      Author: ckeme_01
 */

#ifndef FASTMATH_HPP_
#define FASTMATH_HPP_


#include <cfloat>
#include <cmath>

static const float EXP_UNDERFLOW_THRESHOLD = -4.60f;
static const float LOG_UNDERFLOW_THRESHOLD = 7.50f;
static const float LOG_ZERO = -FLT_MAX;
static const float LOG_ONE = 0.0f;


double EXP (float x);
float LOOKUP (float x);
void LOG_PLUS_EQUALS (float *x, float y);
float LOG_ADD (float x, float y);





#endif /* FASTMATH_HPP_ */
